/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * Inject.java
 *
 * Created on 2005/09/24, 2:29
 *
 */
package jp.co.gihyo.book.di.ch3.ano;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
/**
 *
 * @author arton
 */
@Retention(RetentionPolicy.RUNTIME)
@Target (ElementType.FIELD)
public @interface Inject {
    public enum Type {
        NAME,
        INTERFACE
    }
    Type type() default Type.INTERFACE;
    String value() default "";
}
