/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * StringInjector.java
 *
 * Created on 2005/09/21, 1:42
 *
 */
package jp.co.gihyo.book.di.ch3.intf;

import java.lang.reflect.Method;
import static jp.co.gihyo.book.di.ch3.intf.InjectorHelper.invoke;

/**
 * CWFNVėpNXB
 *
 * @author arton
 */
class StringInjector implements Injector {
    
    Class targetInterface;
    String value;
    Method injector;
    
    /**
     * CWFN^[𐶐B
     * @param initTargetInterface CWFNgΏۂƂȂC^[tFCXB
     * @param initValue CWFNgΏۂ̕B
     */
    StringInjector(Class initTargetInterface, String initValue) {
        targetInterface = initTargetInterface;
        value = initValue;
        for (Method m : targetInterface.getMethods()) {
            if (m.getName().indexOf("inject") == 0 && m.getParameterTypes().length == 1
                    && m.getParameterTypes()[0] == String.class) {
                injector = m;
                break;
            }
        }
    }
 
    public void inject(Injectable target) {
        assert injector != null : "no inject method";
        
        if (targetInterface.isInstance(target)) {
            invoke(injector, target, value);
        }
    }
}
