/*
 * SetterInjectContainerTest.java
 * JUnit based test
 *
 * Created on 2005/09/20, 4:15
 */

package jp.co.gihyo.book.di.ch3.setter;

import junit.framework.*;

/**
 * Zb^[CWFNVsDIReĩeXgB
 * @author arton
 */
public class SetterInjectContainerTest extends TestCase {
    
    static final String TEST_PROP_FILE = "setterdi";
    static final String TEST_OBJ = "settertestobject";
    
    public SetterInjectContainerTest(String testName) {
        super(testName);
    }

    SetterInjectContainer dicon;
    
    protected void setUp() throws Exception {
        dicon = new SetterInjectContainer(TEST_PROP_FILE);
    }

    protected void tearDown() throws Exception {
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(SetterInjectContainerTest.class);
    }

    public static class TestClass {
        String surName;
        public void setSurName(String newSurName) {
            surName = newSurName;
        }
        String givenName;
        public void setGivenName(String newGivenName) {
            givenName = newGivenName;
        }
        int age;
        public void setAge(int newAge) {
            age = newAge;
        }
        TestHelloClass hello;
        public void setHello(TestHelloClass newHello) {
            hello = newHello;
        }
    }
    
    public static class TestHelloClass {
        String message;
        public void setMessage(String newMessage) {
            message = newMessage;
        }
    }
    
    /**
     * NX jp.co.gihyo.book.di.ch2.setter.SetterInjectContainer  getObject \bh̃eXg
     */
    public void testGetObject() {
        TestClass test = (TestClass)dicon.getObject(TEST_OBJ);
        assertEquals("Y", test.givenName);
        assertEquals("RobNX", test.surName);
        assertEquals(27, test.age);
        assertEquals("ɂ₪", test.hello.message);
    }
    
}
