/*
 * ConstructorInjectContainerTest.java
 * JUnit based test
 *
 * Created on 2005/09/20, 20:32
 */

package jp.co.gihyo.book.di.ch3.ctr;

import junit.framework.*;

/**
 * RXgN^CWFNVDIReiEeXgB
 * @author arton
 */
public class ConstructorInjectContainerTest extends TestCase {

    static final String TEST_PROP_FILE = "constructordi";
    static final String TEST_OBJ = "ctrtestobject";

    public ConstructorInjectContainerTest(String testName) {
        super(testName);
    }

    ConstructorInjectContainer dicon;
    
    protected void setUp() throws Exception {
        dicon = new ConstructorInjectContainer(TEST_PROP_FILE);
    }

    protected void tearDown() throws Exception {
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(ConstructorInjectContainerTest.class);
    }

    public static class TestClass {
        public TestClass(String initGivenName, String initSurName, int initAge, TestHelloClass initHello) {
            givenName = initGivenName;
            surName = initSurName;
            age = initAge;
            hello = initHello;
        }
        String surName;
        String givenName;
        int age;
        TestHelloClass hello;
    }
    
    public static class TestHelloClass {
        String message;
        public TestHelloClass(String initMessage) {
            message = initMessage;
        }
    }
    
    /**
     * NX jp.co.gihyo.book.di.ch2.ctr.ConstructorInjectContainer  getObject \bh̃eXg
     */
    public void testGetObject() {
        TestClass test = (TestClass)dicon.getObject(TEST_OBJ);
        assertNotNull(test);
        assertEquals("Y", test.givenName);
        assertEquals("RobNX", test.surName);
        assertEquals(27, test.age);
        assertEquals("ɂ₪", test.hello.message);
    }
    
}
