/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * HelloImpl.java
 *
 * Created on 2005/10/02, 2:40
 *
 */

package jp.co.gihyo.book.di.ch4;

/**
 *@ANXB
 * @author arton
 */
public class HelloImpl implements Hello {
    
    public void greet(String msg) {
        if (msg == null) {
            throw new NullPointerException("msg must not be null");
        }
        System.out.println(msg);
    }

    public String greeting() {
        return "hello world !";
    }
    
}
