/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * TraceInterceptor.java
 *
 * Created on 2005/10/06, 2:45
 *
 */

package jp.co.gihyo.book.di.ch4;

/**
 * g[XC^[Zv^B
 * @author arton
 */
public class TraceInterceptor implements MethodInterceptor.Interceptor {
    
    public void beforeInvoke(java.lang.reflect.Method m, Object[] args) {
        System.out.println("enter " + m.getName());
        for (int i = 0; i < args.length; i++) {
            System.out.println(" arg" + i + ":" + args[i]);
        }
    }

    public void exception(java.lang.reflect.Method m, Object[] args, Throwable e) {
        System.out.println("break " + m.getName());
        System.out.println(" exception:" + e);
    }

    public void afterInvoke(java.lang.reflect.Method m, Object[] args, Object result) {
        System.out.println("exit " + m.getName());
        System.out.println(" result:" + result);
    }
    
}
